package meerkat;

import com.google.protobuf.InvalidProtocolBufferException;
import meerkat.protobuf.BulletinBoardAPI.BulletinBoardMessage;
import meerkat.protobuf.BulletinBoardAPI.UnsignedBulletinBoardMessage;
import meerkat.protobuf.VoterRegistry;

import java.util.List;


/**
 * TODO: add logging
 */

/**
 * Created by Vladimir Eliezer Tokarev on 1/15.2016
 * this class wraps BasicMessage and gives the ability to find wanted tags
 */
public class VoterRegistryMessage {

    public UnsignedBulletinBoardMessage base;

    public VoterRegistryMessage(BulletinBoardMessage message) {
        UnsignedBulletinBoardMessage.Builder unsignedBase =
                UnsignedBulletinBoardMessage.newBuilder().addAllTag(message.getMsg().getTagList());
        unsignedBase.setData(message.getMsg().getData());
        base = unsignedBase.build();
    }

    /**
     * Gets the wanted tag from given basic message
     *
     * @param tagName the name of the tag
     * @return string
     */
    public String GetWantedTagFromBasicMessage(String tagName) {
        List<String> tags = base.getTagList();
        for (int i = 0 ; i < tags.size() ; i++) {
            String tag = tags.get(i);
            if (tag.contains(tagName)) {
                return tag;
            }
        }
        return null;
    }

    /**
     * Gets the creation time milliseconds of the tag adding
     * @return long that represent the creation time
     */
    public long GetCreationTime() throws InvalidProtocolBufferException {
        try {
            VoterRegistry.VoterRegistryMessage wrapper = VoterRegistry.VoterRegistryMessage.parseFrom(base.getData());
            return wrapper.getCreationMiliseconds();
        } catch (InvalidProtocolBufferException e) {
            throw e;
        }
    }
}
